#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <bitset>
#include <random>
using namespace std;

#define int long long

const int Mx = 1e6 + 10;
int A[Mx];
int Js[Mx];
int N, Q, T, M;
string s;
bool f = false, check = true;

signed main() {
    cin >> T >> N >> M;
    for (int i = 1; i <= N; i++) {
        cin >> Js[i];
        if (i == 1) {
            f = Js[i] % 2;
        }
        else if (f != Js[i] % 2) {
            check = false;
        }
    }
    cin >> s;
    if (!check) {
        cout << "No";
        return 0;
    }
    cout << "Yes" << '\n';
    if (T == 1) {
        return 0;
    }
    cout << M / 2 + 1 << '\n';
    if (T == 2) {
        return 0;
    }
    cout << 1 << '\n';
    cout << M / 2 << ' ' << M / 2 + 1;
}
